from ast import operator
from utils import read_config
from utils import save_csv
import lxml.etree as et
import operator

def execute():
    config = read_config('files_list_nonvida.csv')
    prepare_csvs(config)
    
def prepare_csvs(config):
    print('Preparing csv from xmls')
    for file in config:
        name = file['entry_name']
        list_to_save = []
        xml = 'download/feed_'+name+'.xml'
        print(f'Preparing {xml}')
        for event, elem in et.iterparse(xml):
            if elem.tag == "o":
                list_to_save.append({
                    'price_feed': elem.attrib['price'],
                    'stock_feed': elem.attrib['stock'],
                    'sku_feed': elem.attrib['id'],
                    'leadtime_to_ship_feed': file['leadtime_to_ship'],
                })
        newlist = sorted(list_to_save, key=operator.itemgetter('sku_feed'))
        save_csv(f'download/feed_{name}'+'.csv', newlist)
        
        list_to_save = []
        xml = 'download/feed_'+name+'_es.xml'
        print(f'Preparing {xml}')
        for event, elem in et.iterparse(xml):
            if elem.tag == "o":
                list_to_save.append({
                    'price_feed_es': elem.attrib['price'],
                    'stock_feed_es': elem.attrib['stock'],
                    'sku_feed_es': elem.attrib['id'],
                    'leadtime_to_ship_feed_es': file['leadtime_to_ship'],
                })
        newlist = sorted(list_to_save, key=operator.itemgetter('sku_feed_es'))
        save_csv(f'download/feed_{name}'+'_es.csv', newlist)
            
if __name__ == "__main__":
    execute()